﻿Friend Class FrmMain

	Private Sub FrmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		TabControl1.HideNavigationButtons()
		TabPage1.ShowOnlyMe()
	End Sub

	Private Sub ShowPage1(sender As Object, e As EventArgs) Handles BtnBackFromPage2.Click, BtnNextFromPage3.Click
		TabPage1.ShowOnlyMe()
	End Sub

	Private Sub ShowPage2(sender As Object, e As EventArgs) Handles BtnBackFromPage3.Click, BtnNextFromPage1.Click
		TabPage2.ShowOnlyMe()
	End Sub

	Private Sub ShowPage3(sender As Object, e As EventArgs) Handles BtnBackFromPage1.Click, BtnNextFromPage2.Click
		TabPage3.ShowOnlyMe()
	End Sub
End Class

Friend Module Extensions

	<Runtime.CompilerServices.Extension> Public Sub HideNavigationButtons(TabControl As TabControl)
		TabControl.ItemSize = New Drawing.Size(0, 1)
		TabControl.Appearance = TabAppearance.FlatButtons
		TabControl.SizeMode = TabSizeMode.Fixed
	End Sub

	Private Class TabControlPack
		Public TabPages As New List(Of TabPage)
		Public TabControl As TabControl = Nothing
	End Class

	Private ReadOnly TabControlData As New List(Of TabControlPack)

	<Runtime.CompilerServices.Extension> Public Sub ShowTab(TabPage As TabPage)
		PossiblyRegisterTabControlOf(TabPage)
		Dim FittingTabControlData = GetFittingTabControlSettingFor(TabPage)
		If FittingTabControlData IsNot Nothing AndAlso Not FittingTabControlData.TabControl.TabPages.Contains(TabPage) Then FittingTabControlData.TabControl.TabPages.Add(TabPage)
	End Sub

	<Runtime.CompilerServices.Extension> Public Sub HideTab(TabPage As TabPage)
		PossiblyRegisterTabControlOf(TabPage)
		Dim FittingTabControlData = GetFittingTabControlSettingFor(TabPage)
		If FittingTabControlData IsNot Nothing AndAlso FittingTabControlData.TabControl.TabPages.Contains(TabPage) Then FittingTabControlData.TabControl.TabPages.Remove(TabPage)
	End Sub

	<Runtime.CompilerServices.Extension> Public Sub ShowOnlyMe(TabPage As TabPage)
		PossiblyRegisterTabControlOf(TabPage)
		Dim FittingTabControlData = GetFittingTabControlSettingFor(TabPage)
		If FittingTabControlData Is Nothing Then Return
		For Each TabPageToHide In FittingTabControlData.TabControl.TabPages.Cast(Of TabPage).Where(Function(x) x IsNot TabPage)
			FittingTabControlData.TabControl.TabPages.Remove(TabPageToHide)
		Next
		TabPage.ShowTab
	End Sub

	Private Sub PossiblyRegisterTabControlOf(TabPage As TabPage)
		If TabPage.Parent IsNot Nothing AndAlso GetFittingTabControlSettingFor(TabPage) Is Nothing Then
			Dim TabControl = DirectCast(TabPage.Parent, TabControl)
			TabControlData.Add(New TabControlPack With {.TabControl = TabControl, .TabPages = TabControl.TabPages.Cast(Of TabPage).ToList})
		End If
	End Sub

	Private Function GetFittingTabControlSettingFor(TabPage As TabPage) As TabControlPack
		Return TabControlData.FirstOrDefault(Function(x) x.TabPages.Contains(TabPage))
	End Function

End Module